Spread Transformation

When a user sets a object column's fields as spread in the data source schema, the columns will show the first level properties of the object. This is useful for adding a nested object into the TableSheet without having to manually flatten the fields before data binding.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

When a user fetches the following json ("Companies.json") from a server,

[
    {
        "id": "rec0kxKqvmMIFTmnF",
        "createdTime": "2013-04-17T02:38:00.000Z",
        "fields": {
            "Opportunities": [
                "recZgmDrnvRTxTvpI"
            ],
            "Address": "8340 Clarington Avenue, Suite 2500, Culver City, CA 90232",
            "Employees": 4000,
            "Name": "Liberty Pictures",
            "Description": "One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.",
            "Type": "Film Studio",
            "Contacts": [
                "rec1cpyvgqTEzXxjK",
                "recYjwxDhkRIzVvqO"
            ],
            "SumOpp": 50000,
            "Field 11": 4000
        }
    },
    // more items ...
]

and specifies that the "fields" column should be spread,

var dataManager = spread.dataManager();
var myTable = dataManager.addTable("myTable", {
    remote: {
        read: {
            url: './Companies.json'
        }
    },
    schema: {
        columns: {
            fields: {spread: true}
        }
    }
});
myTable.fetch().then(function (data) {
    var myView = myTable.addView("myView");
    sheet.setDataView(myView);
});

then the above nested object will be converted to a plain object.

id createdTime Opportunities Address Employees Name Description Type Contacts SumOpp Field 11
rec0kxKqvmMIFTmnF 2013-04-17T02:38:00.000Z recZgmDrnvRTxTvpI 8340 Clarington Avenue, Suite 2500, Culver City, CA 90232 4000 Liberty Pictures One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989. Film Studio rec1cpyvgqTEzXxjK, recYjwxDhkRIzVvqO 50000 4000
When a user fetches the following json ("Companies.json") from a server, and specifies that the "fields" column should be spread, then the above nested object will be converted to a plain object. id createdTime Opportunities Address Employees Name Description Type Contacts SumOpp Field 11 rec0kxKqvmMIFTmnF 2013-04-17T02:38:00.000Z recZgmDrnvRTxTvpI 8340 Clarington Avenue, Suite 2500, Culver City, CA 90232 4000 Liberty Pictures One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989. Film Studio rec1cpyvgqTEzXxjK, recYjwxDhkRIzVvqO 50000 4000
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 }); initSpread(spread); }; function getDataSource() { return [ { "id": "rec0kxKqvmMIFTmnF", "createdTime": "2013-04-17T02:38:00.000Z", "fields": { "Opportunities": [ "recZgmDrnvRTxTvpI" ], "Address": "8340 Clarington Avenue, Suite 2500, Culver City, CA 90232", "Employees": 4000, "Name": "Liberty Pictures", "Description": "One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.", "Type": "Film Studio", "Contacts": [ "rec1cpyvgqTEzXxjK", "recYjwxDhkRIzVvqO" ], "SumOpp": 50000, "Field 11": 4000 } }, { "id": "rec2lmCylyUPG1wjL", "createdTime": "2013-04-17T02:38:06.000Z", "fields": { "Opportunities": [ "rec0fzGCrvIRC4ivL" ], "Address": "5577 Linnington Ave., Suite 420, Los Angeles, CA 90064\n", "Employees": 350, "Name": "Wolf Searchlight Pictures", "Description": "Wolf Searchlight Pictures is a U.S. film distribution company specializing in independent and foreign films. It exists within the larger Wolf Entertainment Group (which also includes the larger film studio 20th Century Wolf), which is a subsidiary of the American multinational mass media conglomerate 21st Century Wolf, which is a subsidiary of the even larger multinational mass media conglomerate News Group.", "Type": "Film Studio", "Contacts": [ "recNiyDyulWLzUxrD" ], "SumOpp": 225000, "Field 11": 350 } }, { "id": "recZ9wHAmoKOy4viO", "createdTime": "2013-04-17T02:38:13.000Z", "fields": { "Opportunities": [ "recZmvwvrnXNA3xwL" ], "Address": "7000 N. Bronson Avenue, Los Angeles, CA 90004\n", "Employees": 5000, "Name": "Tantamount Studios", "Description": "Tantamount Studios is the fourth largest major film studio in the world, and a subsidiary of the U.S. media conglomerate Avicom. Tantamount was founded in 1912 by the Polish immigrant Mordecai M. Meyers and is one the oldest surviving film studios in the U.S.\nRecent Films:\n\"Homeless Dad\"\n\"Almost Cousins\"\n\"Love, Indubitably\"", "Type": "Film Studio", "SumOpp": 65000, "Field 11": 5000 } } ]; } function initSpread(spread) { spread.suspendPaint(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; var dataManager = spread.dataManager(); // add table var myTable = dataManager.addTable("myTable", { data: getDataSource(), schema: { columns: { fields: { spread: true } } } }); // add view myTable.fetch().then(function () { var myView = myTable.addView("myView", undefined, undefined, { defaultColumnWidth: "*" }); var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row sheet.setDataView(myView); }); spread.resumePaint(); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill --> <script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div id="optionContainer" class="optionContainer"> </div> </div> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; margin: 0; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; }

When a user fetches the following json ("Companies.json") from a server,
and specifies that the "fields" column should be spread,
then the above nested object will be converted to a plain object.
id
createdTime
Opportunities
Address
Employees
Name
Description
Type
Contacts
SumOpp
Field 11
rec0kxKqvmMIFTmnF
2013-04-17T02:38:00.000Z
recZgmDrnvRTxTvpI
8340 Clarington Avenue, Suite 2500, Culver City, CA 90232
4000
Liberty Pictures
One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.
Film Studio
rec1cpyvgqTEzXxjK, recYjwxDhkRIzVvqO
50000
4000
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
function getDataSource() {
return [
{
"id": "rec0kxKqvmMIFTmnF",
"createdTime": "2013-04-17T02:38:00.000Z",
"fields": {
"Opportunities": [
"recZgmDrnvRTxTvpI"
],
"Address": "8340 Clarington Avenue, Suite 2500, Culver City, CA 90232",
"Employees": 4000,
"Name": "Liberty Pictures",
"Description": "One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.",
"Type": "Film Studio",
"Contacts": [
"rec1cpyvgqTEzXxjK",
"recYjwxDhkRIzVvqO"
],
"SumOpp": 50000,
"Field 11": 4000
}
},
{
"id": "rec2lmCylyUPG1wjL",
"createdTime": "2013-04-17T02:38:06.000Z",
"fields": {
"Opportunities": [
"rec0fzGCrvIRC4ivL"
],
"Address": "5577 Linnington Ave., Suite 420, Los Angeles, CA 90064\n",
"Employees": 350,
"Name": "Wolf Searchlight Pictures",
"Description": "Wolf Searchlight Pictures is a U.S. film distribution company specializing in independent and foreign films. It exists within the larger Wolf Entertainment Group (which also includes the larger film studio 20th Century Wolf), which is a subsidiary of the American multinational mass media conglomerate 21st Century Wolf, which is a subsidiary of the even larger multinational mass media conglomerate News Group.",
"Type": "Film Studio",
"Contacts": [
"recNiyDyulWLzUxrD"
],
"SumOpp": 225000,
"Field 11": 350
}
},
{
"id": "recZ9wHAmoKOy4viO",
"createdTime": "2013-04-17T02:38:13.000Z",
"fields": {
"Opportunities": [
"recZmvwvrnXNA3xwL"
],
"Address": "7000 N. Bronson Avenue, Los Angeles, CA 90004\n",
"Employees": 5000,
"Name": "Tantamount Studios",
"Description": "Tantamount Studios is the fourth largest major film studio in the world, and a subsidiary of the U.S. media conglomerate Avicom. Tantamount was founded in 1912 by the Polish immigrant Mordecai M. Meyers and is one the oldest surviving film studios in the U.S.\nRecent Films:\n\"Homeless Dad\"\n\"Almost Cousins\"\n\"Love, Indubitably\"",
"Type": "Film Studio",
"SumOpp": 65000,
"Field 11": 5000
}
}
];
}
export function AppFunc() {
const initSpread = (spread) => {
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
var dataManager = spread.dataManager();
// add table
var myTable = dataManager.addTable("myTable", {
data: getDataSource(),
schema: {
columns: {
fields: { spread: true }
}
}
});
// add view
myTable.fetch().then(function () {
var myView = myTable.addView("myView", undefined, undefined, {
defaultColumnWidth: "*"
});
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
sheet.setDataView(myView);
});
spread.resumePaint();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
function getDataSource() {
return [
{
"id": "rec0kxKqvmMIFTmnF",
"createdTime": "2013-04-17T02:38:00.000Z",
"fields": {
"Opportunities": [
"recZgmDrnvRTxTvpI"
],
"Address": "8340 Clarington Avenue, Suite 2500, Culver City, CA 90232",
"Employees": 4000,
"Name": "Liberty Pictures",
"Description": "One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.",
"Type": "Film Studio",
"Contacts": [
"rec1cpyvgqTEzXxjK",
"recYjwxDhkRIzVvqO"
],
"SumOpp": 50000,
"Field 11": 4000
}
},
{
"id": "rec2lmCylyUPG1wjL",
"createdTime": "2013-04-17T02:38:06.000Z",
"fields": {
"Opportunities": [
"rec0fzGCrvIRC4ivL"
],
"Address": "5577 Linnington Ave., Suite 420, Los Angeles, CA 90064\n",
"Employees": 350,
"Name": "Wolf Searchlight Pictures",
"Description": "Wolf Searchlight Pictures is a U.S. film distribution company specializing in independent and foreign films. It exists within the larger Wolf Entertainment Group (which also includes the larger film studio 20th Century Wolf), which is a subsidiary of the American multinational mass media conglomerate 21st Century Wolf, which is a subsidiary of the even larger multinational mass media conglomerate News Group.",
"Type": "Film Studio",
"Contacts": [
"recNiyDyulWLzUxrD"
],
"SumOpp": 225000,
"Field 11": 350
}
},
{
"id": "recZ9wHAmoKOy4viO",
"createdTime": "2013-04-17T02:38:13.000Z",
"fields": {
"Opportunities": [
"recZmvwvrnXNA3xwL"
],
"Address": "7000 N. Bronson Avenue, Los Angeles, CA 90004\n",
"Employees": 5000,
"Name": "Tantamount Studios",
"Description": "Tantamount Studios is the fourth largest major film studio in the world, and a subsidiary of the U.S. media conglomerate Avicom. Tantamount was founded in 1912 by the Polish immigrant Mordecai M. Meyers and is one the oldest surviving film studios in the U.S.\nRecent Films:\n\"Homeless Dad\"\n\"Almost Cousins\"\n\"Love, Indubitably\"",
"Type": "Film Studio",
"SumOpp": 65000,
"Field 11": 5000
}
}
];
}
export class App extends Component {
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
initSpread(spread) {
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
var dataManager = spread.dataManager();
// add table
var myTable = dataManager.addTable("myTable", {
data: getDataSource(),
schema: {
columns: {
fields: { spread: true }
}
}
});
// add view
myTable.fetch().then(function () {
var myView = myTable.addView("myView", undefined, undefined, {
defaultColumnWidth: "*"
});
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
sheet.setDataView(myView);
});
spread.resumePaint();
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

When a user fetches the following json ("Companies.json") from a server,
and specifies that the "fields" column should be spread,
then the above nested object will be converted to a plain object.
id
createdTime
Opportunities
Address
Employees
Name
Description
Type
Contacts
SumOpp
Field 11
rec0kxKqvmMIFTmnF
2013-04-17T02:38:00.000Z
recZgmDrnvRTxTvpI
8340 Clarington Avenue, Suite 2500, Culver City, CA 90232
4000
Liberty Pictures
One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.
Film Studio
rec1cpyvgqTEzXxjK, recYjwxDhkRIzVvqO
50000
4000
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import './styles.css';
function getDataSource() {
return [
{
"id": "rec0kxKqvmMIFTmnF",
"createdTime": "2013-04-17T02:38:00.000Z",
"fields": {
"Opportunities": [
"recZgmDrnvRTxTvpI"
],
"Address": "8340 Clarington Avenue, Suite 2500, Culver City, CA 90232",
"Employees": 4000,
"Name": "Liberty Pictures",
"Description": "One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.",
"Type": "Film Studio",
"Contacts": [
"rec1cpyvgqTEzXxjK",
"recYjwxDhkRIzVvqO"
],
"SumOpp": 50000,
"Field 11": 4000
}
},
{
"id": "rec2lmCylyUPG1wjL",
"createdTime": "2013-04-17T02:38:06.000Z",
"fields": {
"Opportunities": [
"rec0fzGCrvIRC4ivL"
],
"Address": "5577 Linnington Ave., Suite 420, Los Angeles, CA 90064\n",
"Employees": 350,
"Name": "Wolf Searchlight Pictures",
"Description": "Wolf Searchlight Pictures is a U.S. film distribution company specializing in independent and foreign films. It exists within the larger Wolf Entertainment Group (which also includes the larger film studio 20th Century Wolf), which is a subsidiary of the American multinational mass media conglomerate 21st Century Wolf, which is a subsidiary of the even larger multinational mass media conglomerate News Group.",
"Type": "Film Studio",
"Contacts": [
"recNiyDyulWLzUxrD"
],
"SumOpp": 225000,
"Field 11": 350
}
},
{
"id": "recZ9wHAmoKOy4viO",
"createdTime": "2013-04-17T02:38:13.000Z",
"fields": {
"Opportunities": [
"recZmvwvrnXNA3xwL"
],
"Address": "7000 N. Bronson Avenue, Los Angeles, CA 90004\n",
"Employees": 5000,
"Name": "Tantamount Studios",
"Description": "Tantamount Studios is the fourth largest major film studio in the world, and a subsidiary of the U.S. media conglomerate Avicom. Tantamount was founded in 1912 by the Polish immigrant Mordecai M. Meyers and is one the oldest surviving film studios in the U.S.\nRecent Films:\n\"Homeless Dad\"\n\"Almost Cousins\"\n\"Love, Indubitably\"",
"Type": "Film Studio",
"SumOpp": 65000,
"Field 11": 5000
}
}
];
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
let spread = $event.spread;
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
var dataManager = spread.dataManager();
// add table
var myTable = dataManager.addTable("myTable", {
data: getDataSource(),
schema: {
columns: {
fields: { spread: true }
}
}
});
// add view
myTable.fetch().then(function() {
var myView = myTable.addView("myView", undefined, undefined, {
defaultColumnWidth: "*"
});
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
sheet.setDataView(myView);
});
spread.resumePaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
margin: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Spread Transformation

When a user sets a object column's fields as spread in the data source schema, the columns will show the first level properties of the object. This is useful for adding a nested object into the TableSheet without having to manually flatten the fields before data binding.

Description
app.vue
index.html
Copy to CodeMine

When a user fetches the following json ("Companies.json") from a server,

[
    {
        "id": "rec0kxKqvmMIFTmnF",
        "createdTime": "2013-04-17T02:38:00.000Z",
        "fields": {
            "Opportunities": [
                "recZgmDrnvRTxTvpI"
            ],
            "Address": "8340 Clarington Avenue, Suite 2500, Culver City, CA 90232",
            "Employees": 4000,
            "Name": "Liberty Pictures",
            "Description": "One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.",
            "Type": "Film Studio",
            "Contacts": [
                "rec1cpyvgqTEzXxjK",
                "recYjwxDhkRIzVvqO"
            ],
            "SumOpp": 50000,
            "Field 11": 4000
        }
    },
    // more items ...
]

and specifies that the "fields" column should be spread,

var dataManager = spread.dataManager();
var myTable = dataManager.addTable("myTable", {
    remote: {
        read: {
            url: './Companies.json'
        }
    },
    schema: {
        columns: {
            fields: {spread: true}
        }
    }
});
myTable.fetch().then(function (data) {
    var myView = myTable.addView("myView");
    sheet.setDataView(myView);
});

then the above nested object will be converted to a plain object.

id createdTime Opportunities Address Employees Name Description Type Contacts SumOpp Field 11
rec0kxKqvmMIFTmnF 2013-04-17T02:38:00.000Z recZgmDrnvRTxTvpI 8340 Clarington Avenue, Suite 2500, Culver City, CA 90232 4000 Liberty Pictures One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989. Film Studio rec1cpyvgqTEzXxjK, recYjwxDhkRIzVvqO 50000 4000
When a user fetches the following json ("Companies.json") from a server, and specifies that the "fields" column should be spread, then the above nested object will be converted to a plain object. id createdTime Opportunities Address Employees Name Description Type Contacts SumOpp Field 11 rec0kxKqvmMIFTmnF 2013-04-17T02:38:00.000Z recZgmDrnvRTxTvpI 8340 Clarington Avenue, Suite 2500, Culver City, CA 90232 4000 Liberty Pictures One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989. Film Studio rec1cpyvgqTEzXxjK, recYjwxDhkRIzVvqO 50000 4000
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> </div> </template> <script setup> import GC from "@mescius/spread-sheets"; import { ref } from "vue"; import "@mescius/spread-sheets-tablesheet"; import "@mescius/spread-sheets-vue"; const spreadRef = ref(null); function initSpread(spread) { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; var dataManager = spread.dataManager(); // add table var myTable = dataManager.addTable("myTable", { data: getDataSource(), schema: { columns: { fields: { spread: true } } } }); // add view myTable.fetch().then(function () { var myView = myTable.addView("myView", undefined, undefined, { defaultColumnWidth: "*" }); var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row sheet.setDataView(myView); }); spread.resumePaint(); } function getDataSource() { return [ { "id": "rec0kxKqvmMIFTmnF", "createdTime": "2013-04-17T02:38:00.000Z", "fields": { "Opportunities": [ "recZgmDrnvRTxTvpI" ], "Address": "8340 Clarington Avenue, Suite 2500, Culver City, CA 90232", "Employees": 4000, "Name": "Liberty Pictures", "Description": "One of the minor studios of Hollywood's Golden Age, Liberty Pictures was ultimately acquired by Japanese multinational media conglomerate Cony in 1989.", "Type": "Film Studio", "Contacts": [ "rec1cpyvgqTEzXxjK", "recYjwxDhkRIzVvqO" ], "SumOpp": 50000, "Field 11": 4000 } }, { "id": "rec2lmCylyUPG1wjL", "createdTime": "2013-04-17T02:38:06.000Z", "fields": { "Opportunities": [ "rec0fzGCrvIRC4ivL" ], "Address": "5577 Linnington Ave., Suite 420, Los Angeles, CA 90064\n", "Employees": 350, "Name": "Wolf Searchlight Pictures", "Description": "Wolf Searchlight Pictures is a U.S. film distribution company specializing in independent and foreign films. It exists within the larger Wolf Entertainment Group (which also includes the larger film studio 20th Century Wolf), which is a subsidiary of the American multinational mass media conglomerate 21st Century Wolf, which is a subsidiary of the even larger multinational mass media conglomerate News Group.", "Type": "Film Studio", "Contacts": [ "recNiyDyulWLzUxrD" ], "SumOpp": 225000, "Field 11": 350 } }, { "id": "recZ9wHAmoKOy4viO", "createdTime": "2013-04-17T02:38:13.000Z", "fields": { "Opportunities": [ "recZmvwvrnXNA3xwL" ], "Address": "7000 N. Bronson Avenue, Los Angeles, CA 90004\n", "Employees": 5000, "Name": "Tantamount Studios", "Description": "Tantamount Studios is the fourth largest major film studio in the world, and a subsidiary of the U.S. media conglomerate Avicom. Tantamount was founded in 1912 by the Polish immigrant Mordecai M. Meyers and is one the oldest surviving film studios in the U.S.\nRecent Films:\n\"Homeless Dad\"\n\"Almost Cousins\"\n\"Love, Indubitably\"", "Type": "Film Studio", "SumOpp": 65000, "Field 11": 5000 } } ]; } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } </script> <style scoped> #app { height: 100%; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; margin: 0; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);